import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Color;

/**
 * Write a description of class Connection here.
 * 
 * @author Taylor Born
 * @version May 2012
 */
public class Connection extends Actor
{
    private Node n1, n2;
    private int weight = 0;
    private Label label = new Label("0");

    public Connection(Node nA, Node nB)
    {
        n1 = nA;
        n1.addConnection(this);
        n2 = nB;
        n2.addConnection(this);
        paint(Color.BLACK);
    }
    public Connection(Connection c)
    {
        n1 = c.getN1();
        n2 = c.getN2();
        weight = c.getWeight();
        label.update(weight + "");
        paint(Color.RED);
    }
    public void paint(Color c)
    {
        GreenfootImage pic = new GreenfootImage(Math.abs(n1.getX() - n2.getX()) + 1, Math.abs(n1.getY() - n2.getY()) + 1);
        pic.setColor(c);
        if (pic.getWidth() == 1 || pic.getHeight() == 1)
            pic.fill();
        else
        {
            boolean TopToBottom = (n1.getX() < n2.getX() ? n1 : n2).getY() < (n1.getX() >= n2.getX() ? n1 : n2).getY();
            Point p = new Point(1, TopToBottom ? 1 : pic.getHeight() - 1);
            Point p2 = new Point(pic.getWidth() - 1, TopToBottom ? pic.getHeight() - 1 : 1);
            pic.drawLine((int)p.getX(), (int)p.getY(), (int)p2.getX(), (int)p2.getY());
        }
        setImage(pic);
    }
    public boolean hits(Point p)
    {
        Point pnt = new Point(getImage().getWidth() / 2 + (int)p.getX() - getX(), getImage().getHeight() / 2 + (int)p.getY() - getY());
        //if (inBounds(pnt) && getImage().getColorAt((int)pnt.getX(), (int)pnt.getY()).equals(Color.BLACK))
        //    return true;
        for (int r = -1; r < 2; r++)
            for (int c = -1; c < 2; c++)
                if (inBounds(new Point((int)pnt.getX() + c, (int)pnt.getY() + r)) && getImage().getColorAt((int)pnt.getX() + c, (int)pnt.getY() + r).equals(Color.BLACK))
                    return true;
        return false;
    }
    private boolean inBounds(Point pnt)
    {
        return pnt.getX() > -1 && pnt.getY() > -1 && pnt.getX() < getImage().getWidth() && pnt.getY() < getImage().getHeight();
    }
    public void act() 
    {
        if ((n1.getX() + n2.getX()) / 2 != getX() || (n1.getY() + n2.getY()) / 2 != getY())
        {
            setLocation((n1.getX() + n2.getX()) / 2, (n1.getY() + n2.getY()) / 2);
            label.setLocation(getX(), getY());
            paint(Color.BLACK);
        }
    }
    public void addedToWorld(World world)
    {
        world.addObject(label, getX(), getY());
    }
    public void setWeight(int w)
    {
        weight = w;
        label.update(w + "");
    }
    public int getWeight()
    {
        return weight;
    }
    public Node getN1()
    {
        return n1;
    }
    public Node getN2()
    {
        return n2;
    }
    public void remove()
    {
        getWorld().removeObject(label);
        getWorld().removeObject(this);
    }
    public Node getOther(Node n)
    {
        if (n == n1)
            return n2;
        return n1;
    }
    public void breakConnection()
    {
        n1.removeConnection(this);
        n2.removeConnection(this);
        remove();
    }
}