import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import java.awt.Color;

/**
 * Write a description of class InputBox here.
 * 
 * @author Taylor Born
 * @version May 2012
 */
public class InputBox extends Actor
{
    private int boxOffset;
    private TextBox box;
    private Button btn = new Button("Enter", new Point(45 , 15));
    private boolean done;

    public InputBox(String prompt, String text, String acceptOnly, int limit)
    {
        box = new TextBox(new Point(60, 15), text);
        box.acceptOnly(acceptOnly);
        box.setMaxLength(limit);
        Font font = new Font("Courier New", Font.BOLD, 12);
        Graphics2D graphics = (new GreenfootImage(1, 1)).getAwtImage().createGraphics();
        graphics.setFont(font);
        FontMetrics fm = graphics.getFontMetrics();
        
        boxOffset = fm.charsWidth(prompt.toCharArray(), 0, prompt.length()) + 6;
        graphics.dispose();
        GreenfootImage pic = new GreenfootImage(boxOffset + 60 + 3, 40);
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        pic.setFont(font);
        pic.drawString(prompt, 3, pic.getHeight() / 2 - 8 + font.getSize() / 2 - 2);
        
        setImage(pic);
    }
    public boolean isDone()
    {
        return done;
    }
    public String getInput()
    {
        return box.getText();
    }
    public void addedToWorld(World world)
    {
        world.addObject(box, getX() - getImage().getWidth() / 2 + boxOffset + 30, getY() - 8);
        world.addObject(btn, getX(), getY() + 8);
    }
    public void act()
    {
        if (btn.wasClicked())
            done = true;
    }
    public void remove()
    {
        getWorld().removeObject(box);
        getWorld().removeObject(btn);
        getWorld().removeObject(this);
    }
}