import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;
import java.util.List;
import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;

/**
 * Write a description of class Node here.
 * 
 * @author Taylor Born
 * @version May 2012
 */
public class Node extends Actor
{
    private int label = -1;
    //private ArrayList<Node> nodes = new ArrayList<Node>();
    private ArrayList<Connection> connections = new ArrayList<Connection>();
    private int col;
    
    private static int count = 0; // 0-285

    public static void resetCount()
    {
        count = 0;
    }
    public Node()
    {
        
    }
    public Node(String s)
    {
        label = s.charAt(0) - 'A';
        if (s.length() > 1)
            label = (s.charAt(1) - '0' + 1) * 26 + label;
    }
    public void addedToWorld(World world)
    {
        if (label == -1)
        {
            List<Object> nodes = world.getObjects(Node.class);
            for (int i = 0; i < nodes.size(); i++)
            {
                Node oN = (Node)nodes.get(i);
                if (oN != this)
                {
                    if (oN.getLabel() == count)
                    {
                        count++;
                        i = -1;
                    }
                }
            }
            label = count++;
        }
        resetColor();
    }
    public void act() 
    {
        
    }
    public int getLabel()
    {
        return label;
    }
    public String getLabelName()
    {
        String s = "" + (char)('A' + label % 26);
        int i = label / 26;
        if (i > 0)
            s += (i - 1);
        return s;
    }
    public void addConnection(Connection c)
    {
        connections.add(c);
    }
    public void removeConnection(Connection c)
    {
        connections.remove(c);
    }
    public void delete()
    {
        while (!connections.isEmpty())
            connections.get(0).breakConnection();
        getWorld().removeObject(this);
    }
    public boolean connectsTo(Node n)
    {
        ConnectionIterator ci = getIterator();
        while (ci.hasNext())
            if (ci.getNext() == n)
                return true;
        return false;
    }
    public ConnectionIterator getIterator()
    {
        return new ConnectionIterator();
    }
    public int getConnectionCount()
    {
        return connections.size();
    }
//     public void pointAndConnectTo(Node n)
//     {
//         if (!nodes.contains(n))
//             getWorld().addObject(new Connection(this, n), (getX() + n.getX()) / 2, (getY() + n.getY()) / 2);
//         pointTo(n);
//     }
//     public void pointTo(Node n)
//     {
//         if (!nodes.contains(n))
//             nodes.add(n);
//     }
//     public ArrayList<Node> getNodes()
//     {
//         return nodes;
//     }
//     public void removeNode(Node n)
//     {
//         nodes.remove(n);
//     }
    public void color(int c, Color color)
    {
        col = c;
        GreenfootImage pic = new GreenfootImage(20, 20);
        pic.setColor(color);
        pic.fillOval(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        pic.setFont(new Font("Courier New", Font.BOLD, 12));
        String s = getLabelName();
        pic.setColor(new Color(255 - color.getRed(), 255 - color.getGreen(), 255 - color.getBlue()));
        Graphics2D graphics = pic.getAwtImage().createGraphics();
        graphics.setFont(pic.getFont());
        FontMetrics fm = graphics.getFontMetrics();
        graphics.dispose();
        pic.drawString(s, 10 - fm.charsWidth(s.toCharArray(), 0, s.length()) / 2, 14);
        setImage(pic);
    }
    public int getColor()
    {
        return col;
    }
    public boolean hasColor()
    {
        return col != -1;
    }
    public void resetColor()
    {
        color(-1, Color.BLACK);
//         col = -1;
//         GreenfootImage pic = new GreenfootImage(20, 20);
//         pic.fillOval(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
//         setImage(pic);
    }
    
    class ConnectionIterator
    {
        private int i = 0;
        
        public Node getNext()
        {
            return connections.get(i++).getOther(Node.this);
        }
        public int getThisWeight()
        {
            return connections.get(i).getWeight();
        }
        public boolean hasNext()
        {
            return i < connections.size();
        }
    }
    
}