import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Point;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics2D;
import java.awt.Color;

/**
 * Write a description of class SPWindow here.
 * 
 * @author Taylor Born
 * @version May 2012
 */
public class SPWindow extends Actor
{
    private TextBox inputA = new TextBox(new Point(36, 15), "");
    private int iAOffset;
    private TextBox inputB = new TextBox(new Point(36, 15), "");
    private int iBOffset;
    private Button btnEnter = new Button("Enter", new Point(45 , 15));
    private Button btnClose = new Button("Close", new Point(45 , 15));
    private TextBox output;
    private Point dragging;

    public SPWindow()
    {
        inputA.acceptOnly("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
        inputA.setMaxLength(2);
        inputB.acceptOnly("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789");
        inputB.setMaxLength(2);
        Font font = new Font("Courier New", Font.BOLD, 12);
        Graphics2D graphics = (new GreenfootImage(1, 1)).getAwtImage().createGraphics();
        graphics.setFont(font);
        FontMetrics fm = graphics.getFontMetrics();
        String fromStr = "From: ";
        int fromW = fm.charsWidth(fromStr.toCharArray(), 0, fromStr.length());
        String toStr = "To: ";
        int toW = fm.charsWidth(toStr.toCharArray(), 0, toStr.length());
        int t = fromW + 36 + 5 + toW + 36;
        GreenfootImage pic = new GreenfootImage(t + 4, 78);
        pic.setColor(Color.WHITE);
        pic.fill();
        pic.setColor(Color.BLACK);
        pic.drawRect(0, 0, pic.getWidth() - 1, pic.getHeight() - 1);
        pic.setFont(font);
        pic.drawString(fromStr, pic.getWidth() / 2 - t / 2, fm.getHeight());
        pic.drawString(toStr, pic.getWidth() / 2 + t / 2 - 36 - toW, fm.getHeight());
        iAOffset = -t / 2 + fromW + 18;
        iBOffset = t / 2 - 18;
        setImage(pic);
        graphics.dispose();
        output = new TextBox(new Point(pic.getWidth() - 6, 38), "");
        output.setReadOnly(true);
    }
    public void act()
    {
        MouseInfo mouse = Greenfoot.getMouseInfo();
        if (Greenfoot.mousePressed(this))
            dragging = new Point(mouse.getX() - getX(), mouse.getY() - getY());
        if (Greenfoot.mouseClicked(null) || Greenfoot.mouseDragEnded(null))
            dragging = null;
        if (dragging != null && (Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null)))
        {
            setLocation(mouse.getX() - (int)dragging.getX(), mouse.getY() - (int)dragging.getY());
            arrangeComponents();
        }
        if (btnEnter.wasClicked())
        {
            Node n1 = Graphs.main.getNode(inputA.getText().toUpperCase());
            Node n2 = Graphs.main.getNode(inputB.getText().toUpperCase());
            if (n1 == null || n2 == null)
                output.setText("Invalid Entry");
            else
            {
                output.setText(Graphs.main.findShortestPath(n1, n2));
                System.out.println(output.getText());
            }
        }
        if (btnClose.wasClicked())
        {
            getWorld().removeObject(inputA);
            getWorld().removeObject(inputB);
            getWorld().removeObject(btnEnter);
            getWorld().removeObject(btnClose);
            getWorld().removeObject(output);
            getWorld().removeObject(this);
        }
    }
    public void addedToWorld(World world)
    {
        world.addObject(inputA, getX() + iAOffset, getY() - getImage().getHeight() / 2 + 9);
        world.addObject(inputB, getX() + iBOffset, getY() - getImage().getHeight() / 2 + 9);
        world.addObject(btnEnter, getX() - btnEnter.getImage().getWidth() / 2 - 2, getY() - 12);
        world.addObject(btnClose, getX() + btnClose.getImage().getWidth() / 2 + 2, getY() - 12);
        world.addObject(output, getX(), getY() + 17);
    }
    public void arrangeComponents()
    {
        inputA.setLocation(getX() + iAOffset, getY() - getImage().getHeight() / 2 + 9);
        inputB.setLocation(getX() + iBOffset, getY() - getImage().getHeight() / 2 + 9);
        btnEnter.setLocation(getX() - btnEnter.getImage().getWidth() / 2 - 2, getY() - 12);
        btnClose.setLocation(getX() + btnClose.getImage().getWidth() / 2 + 2, getY() - 12);
        output.setLocation(getX(), getY() + 17);
        
    }
}