import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
import java.awt.Point;

/**
 * Write a description of class Screen here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
public class Screen  extends World
{
    public static Screen main;
    private Menu menu;
    private TextBox input = new TextBox(new Point(161, 100), "");
    private TextBox output = new TextBox(new Point(161, 50), "");
    private Button btnEnter = new Button("Calculate", new Point(161, 23));
    private int state = 0;
    private TextBox inputY = new TextBox(new Point(161, 100), "");
    private Graph myGraph = new Graph();
    
    public Screen()
    {
        super(400, 300, 1);
        setPaintOrder(Menu.class);
        main = this;
        CodeKeyUser.enter();
        setUpMenu();
        input.acceptOnly("0123456789.+-*/( )^");
        inputY.acceptOnly("0123456789.+-*/( )^x");
        addObject(input, 100, 100);
        addObject(output, 100, 215);
        output.setReadOnly(true);//setEnabled(false);
        addObject(btnEnter, 100, 170);
        Greenfoot.start();
    }
    private void setUpMenu()
    {
        ArrayList<String> menuStr = new ArrayList<String>(){{ add("Window"); }};
        menu = new Menu(menuStr, new Point(0, 0));
        menu.addItemsAsSet("Window/", new ArrayList<String>(){{ add("Calculator"); add("Y="); add("Graphs"); }}, "Calculator");
        addObject(menu, 0, 0);
    }
    public void act()
    {
        if (btnEnter.wasClicked())
        {
            String s = input.getText();
            if (!checkSyntax(s))
                output.setText("Syntax error!");
            else
                if (state == 0)
                    output.setText(breakApart("0 + " + s) + "");
                else if (state == 1)
                {
                    s = inputY.getText();
                    myGraph.clear();
                    for (double i = myGraph.xMin; i <= myGraph.xMax; i += myGraph.xIncr)
                    {
                        double y = breakApart("0+" + s.replace("x", "(" + (i) + ")"));
                        //String str = y + "";
                        myGraph.plot(i, y);
                    }
                }
        }
        listenToMenu();
    }
    public ArrayList<Double> findDiscontinuity(String s)
    {
        return null;
    }
    public boolean checkSyntax(String s)
    {
        int numP = 0;
        char last = 0;
        boolean space = false;
        boolean dec = false;
        s = s.trim();
        for (int i = 0; i < s.length(); i++)
        {
            char c = s.charAt(i);
            if (last == '.' && (c < 48 || c > 57))
                return false;
            if (c == '.' && dec)
                return false;
            if (c < 48 || c > 57)
                dec = false;
            if (c == '-' && "^+-*/".contains(last + ""))
            {
                i++;
                if (i > s.length() - 1)
                    return false;
                c = s.charAt(i);
                if (c != '(' && (c < 48 || c > 57) && c != '.')
                    return false;
                last = '-';
            }
            if ("^+-*/".contains(c + "") && "^+-*/".contains(last + ""))
                return false;
            if (c == ' ')
                space = true;
            else
            {
                if (c == '.')
                    dec = true;
                if (c > 47 && c < 58)
                {
                    if (space && last > 47 && last < 58)
                        return false;
                }
                else
                {
                    switch (c)
                    {
                        case '(':   numP++;
                                    break;
                        case ')':   numP--; 
                                    if (numP == -1 || last == '(' || "^+-*/".contains(last + ""))
                                        return false;
                                    break;
                    }
                }
                last = c;
                space = false;
            }
        }
        if (numP != 0 || "^+-*/.".contains(last + ""))
            return false;
        return true;
    }
    public double breakApart(String s)
    {
        s = s.trim();
        ArrayList<Object> terms = new ArrayList<Object>();
        for (int i = 0; i < s.length(); i++)
        {
            char c = s.charAt(i);
            if ((c >= '0' && c <= '9') || c == '.' || (c == '-' && (terms.size() == 0 || terms.get(terms.size() - 1) instanceof Character)))
            {
                Double d = null;
                if (c == '-')
                    for (int q = i + 1; true; q++)
                        if (s.charAt(q) != ' ')
                        {
                            if (s.charAt(q) == '(')
                            {
                                int p = 0;
                                for (int k = q + 1; k < s.length(); k++)
                                {
                                    if (s.charAt(k) == '(')
                                        p++;
                                    else if (s.charAt(k) == ')')
                                    {
                                        if (p == 0)
                                        {
                                            d = -breakApart(s.substring(q + 1, k));
                                            i = k;
                                            break;
                                        }
                                        else
                                            p--;
                                    }
                                }
                            }
                            break;
                        }
                if (d == null)
                {
                    if (terms.size() > 0 && !(terms.get(terms.size() - 1) instanceof Character))
                        terms.add('*');
                    for (int k = i + 1; k < s.length(); k++)
                    {
                        char cc = s.charAt(k);
                        if ((cc < 48 || cc > 57) && cc != '.')
                        {
                            d = Double.parseDouble(s.substring(i, k));
                            i = k - 1;
                            break;
                        }
                    }
                    if (d == null)
                    {
                        d = Double.parseDouble(s.substring(i));
                        i = s.length();
                    }
                }
                terms.add(d);
            }
            else if ("-+/*^".contains(c + ""))
                terms.add(c);
            else if (c == '(')
            {
                if (terms.size() > 0 && !(terms.get(terms.size() - 1) instanceof Character))
                    terms.add('*');
                int p = 0;
                for (int k = i + 1; k < s.length(); k++)
                {
                    if (s.charAt(k) == '(')
                        p++;
                    else if (s.charAt(k) == ')')
                    {
                        if (p == 0)
                        {
                            terms.add(breakApart(s.substring(i + 1, k)));
                            i = k;
                            break;
                        }
                        else
                            p--;
                    }
                }
            }
        }
        for (String o = "^,*/,+-,"; o.length() > 0; o = o.substring(o.indexOf(",") + 1))
            for (int i = 0; i + 2 < terms.size(); i += 2)
                if (o.substring(0, o.indexOf(",")).contains((Character)terms.get(i + 1) + ""))
                {
                    terms.set(i, binaryOp((Character)terms.get(i + 1), (Double)terms.get(i), (Double)terms.get(i + 2)));
                    terms.remove(i + 1);
                    terms.remove(i + 1);
                    i -= 2;
                }
        return (Double)terms.get(0);
    }
    public Double binaryOp(char op, double numA, double numB)
    {
        switch (op)
        {
            case '+':   return numA + numB;
            case '-':   return numA - numB;
            case '/':   return numA / numB;
            case '^':   return Math.pow(numA, numB);
            default:    return numA * numB;
        }
    }
    public void listenToMenu()
    {
        String s = menu.getItemPressed();
        if (s != null)
        {
            if (s.startsWith("Window/"))
            {
                s = s.substring(s.indexOf("/") + 1);
                if (s.equals("Calculator/"))
                {
                    if (state == 1)
                    {
                        removeObject(inputY);
                        removeObject(myGraph);
                        addObject(input, 100, 100);
                        addObject(output, 100, 215);
                        btnEnter.setText("Calculate");
                    }
                    state = 0;
                }
                else if (s.equals("Y=/"))
                {
                    if (state == 0)
                    {
                        removeObject(input);
                        removeObject(output);
                        addObject(inputY, 100, 100);
                        btnEnter.setText("Graph");
                        addObject(myGraph, 284, 150);
                    }
                    state = 1;
                }
                else if (s.equals("Graphs/"))
                    Greenfoot.setWorld(Graphs.main);
            }
        }
    }
    public void showCalculator()
    {
        menu.provokeItem("Window/Calculator");
    }
    public void showXY()
    {
        menu.provokeItem("Window/Y=");
    }
}